/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.region.flags;

import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * ChangedMode defines that a Region has changed or not
 */
@Getter
@AllArgsConstructor
public enum ChangedMode implements Flag.Value<ChangedMode> {

    NO_CHANGE("FLAG_CHANGED_NO_CHANGE", false),
    HAS_CHANGE("FLAG_CHANGED_HAS_CHANGE", true);

    private static ChangedMode[] values;
    private final String chatValue;
    private final Boolean changed;

    @Override
    public ChangedMode[] getValues() {
        if (ChangedMode.values == null) {
            ChangedMode.values = ChangedMode.values();
        }
        return ChangedMode.values;
    }

    @Override
    public ChangedMode getValue() {
        return this;
    }

    @Override
    public ChangedMode getValueOf(final String name) {
        try {
            return ChangedMode.valueOf(name.toUpperCase());
        } catch (IllegalArgumentException e) {
            return NO_CHANGE;
        }
    }
}